Bug 35661 - SecurityAlgorithms.HmacSha256Signature is not supported by System.IdentityModel.Tokens.InMemorySymmetricSecurityKey
Summary: SecurityAlgorithms.HmacSha256Signature is not supported by System.IdentityMod...
Status: RESOLVED FIXED
Alias: None
Product: Class Libraries
Classification: Mono
Component: WCF assemblies (show other bugs)
Version: master
Hardware: PC Linux
: --- normal
Target Milestone: Untriaged
Assignee: Bugzilla
URL:
Depends on:
Blocks:
 
Reported: 2015-11-08 07:33 UTC by af4178a2
Modified: 2017-11-29 19:01 UTC (History)
5 users (show)

Tags:
Is this bug a regression?: ---
Last known good build:


Attachments
NUnit tests (652 bytes, text/x-csharp)
2015-11-08 07:33 UTC, af4178a2
Details
Proposed patch (1.55 KB, patch)
2015-11-08 07:34 UTC, af4178a2
Details
Proposed patch (fixed) (795 bytes, patch)
2015-11-08 07:36 UTC, af4178a2
Details


Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description af4178a2 2015-11-08 07:33:05 UTC
The method GetKeyedHashAlgorithm of InMemorySymmetricSecurityKey class with SecurityAlgorithms.HmacSha256Signature as argument throws System.NotSupportedException.

The code which creates the HMACSHA256 instance is commented out on mono master branch without any obvious reason: https://github.com/mono/mono/blob/master/mcs/class/System.IdentityModel/System.IdentityModel.Tokens/InMemorySymmetricSecurityKey.cs#L126

Also the method IsSupportedAlgorithm returns false when specifying SecurityAlgorithms.HmacSha256Signature.

HMACSHA256 is already properly supported by mono, therefore HMACSHA256 should be enabled for compatibility reasons.
Comment 1 af4178a2 2015-11-08 07:33:41 UTC
Created attachment 13720 [details]
NUnit tests
Comment 2 af4178a2 2015-11-08 07:34:29 UTC
Created attachment 13721 [details]
Proposed patch
Comment 3 af4178a2 2015-11-08 07:36:42 UTC
Created attachment 13722 [details]
Proposed patch (fixed)
Comment 4 Alex Regueiro 2017-09-06 18:14:43 UTC
Just curious, why hasn't this patch been merged yet? I'm running into this issue too.
Comment 5 Marek Safar 2017-09-07 09:03:29 UTC
Could you please convert your test and patch into Mono Pull Request

Thank you
Comment 6 Bernhard Urban 2017-11-29 19:01:04 UTC
fixed with https://github.com/mono/mono/pull/6130